<?php
namespace Faturamento\Repositories;

class Obspropfas extends \Doctrine\ORM\EntityRepository
{
    public static function getTxObsProposta($nrProposta, $nrVersao, $nrOrg)
    {
        $sql = "SELECT TXOBSPROPFAS
                  FROM OBSPROPFAS
                 WHERE NRPROPOSFAS  = :P_PROPOSTA
                   AND NRVERPROPFAS = :P_VERSAO
                   AND NRORG        = :P_ORG";

        $params = array("P_PROPOSTA" => $nrProposta,
                        "P_VERSAO"   => $nrVersao,
                        "P_ORG"      => $nrOrg);

        try{
            return \Setforms2\Shared\Connection::getInstance()->fetchAll($sql, $params);
        } catch(\Exception $e) {
            throw $e;
        }
    }

    public function insertObservacaoPropostaComercial($campos){
        $sql = "INSERT INTO OBSPROPFAS
                    (NRPROPOSFAS, NRVERPROPFAS, TXOBSPROPFAS, DTINCLUSAO, NRORG)
                 VALUES
                    (:NRPROPOSFAS, :NRVERPROPFAS, RAWTOHEX(:TXOBSPROPFAS), SYSDATE, :NRORG)";

        $params = array(
            "NRPROPOSFAS"  => $campos['NRPROPOSFAS'],
            "NRVERPROPFAS" => $campos['NRVERPROPFAS'],
            "TXOBSPROPFAS" => $campos['TXOBSPROPFAS'],
            "NRORG"        => $campos['NRORG'],
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function atualizaObservacaoPropostaComercial($campos){
        $sql = "UPDATE OBSPROPFAS
                   SET TXOBSPROPFAS = RAWTOHEX(:TXOBSPROPFAS)
                 WHERE NRPROPOSFAS  = :NRPROPOSFAS
                   AND NRVERPROPFAS = :NRVERPROPFAS
                   AND NRORG        = :NRORG";

        $params = array(
            "NRPROPOSFAS"  => $campos['NRPROPOSFAS'],
            "NRVERPROPFAS" => $campos['NRVERPROPFAS'],
            "TXOBSPROPFAS" => $campos['TXOBSPROPFAS'],
            "NRORG"        => $campos['NRORG'],
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }

    public function deleteObservacaoPropostaComercial($nrProposta, $nrVersao){
        $sql = "DELETE FROM OBSPROPFAS
                 WHERE NRPROPOSFAS   = :NRPROPOSFAS
                   AND NRVERPROPFAS  = :NRVERPROPFAS";

        $params = array(
            "NRPROPOSFAS"  => $nrProposta,
            "NRVERPROPFAS" => $nrVersao
        );

        $result = $this->_em->getConnection()->executeQuery($sql, $params);

        return count($result) > 0 ? $result : false;
    }
}